/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or aag_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with aag or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 14 "../../lib/cgraph/grammar.y"


#include <stdio.h>  /* SAFE */
#include <cghdr.h>	/* SAFE */
extern void aagerror(char *);	/* gets mapped to aagerror, see below */

#ifdef _WIN32
#define gettxt(a,b)	(b)
#endif

static char Key[] = "key";
static int SubgraphDepth = 0;

typedef union s {					/* possible items in generic list */
		Agnode_t		*n;
		Agraph_t		*subg;
		Agedge_t		*e;
		Agsym_t			*asym;	/* bound attribute */
		char			*name;	/* unbound attribute */
		struct item_s	*list;	/* list-of-lists (for edgestmt) */
} val_t;

typedef struct item_s {		/* generic list */
	int				tag;	/* T_node, T_subgraph, T_edge, T_attr */
	val_t			u;		/* primary element */
	char			*str;	/* secondary value - port or attr value */
	struct item_s	*next;
} item;

typedef struct list_s {		/* maintain head and tail ptrs for fast append */
	item			*first;
	item			*last;
} list_t;

typedef struct gstack_s {
	Agraph_t *g;
	Agraph_t *subg;
	list_t	nodelist,edgelist,attrlist;
	struct gstack_s *down;
} gstack_t;

/* functions */
static void appendnode(char *name, char *port, char *sport);
static void attrstmt(int tkind, char *macroname);
static void startgraph(char *name, int directed, int strict);
static void getedgeitems(int x);
static void newedge(Agnode_t *t, char *tport, Agnode_t *h, char *hport, char *key);
static void edgerhs(Agnode_t *n, char *tport, item *hlist, char *key);
static void appendattr(char *name, char *value);
static void bindattrs(int kind);
static void applyattrs(void *obj);
static void endgraph(void);
static void endnode(void);
static void endedge(void);
static void freestack(void);
static char* concat(char*, char*);
static char* concatPort(char*, char*);

static void opensubg(char *name);
static void closesubg(void);

/* global */
static Agraph_t *G;				/* top level graph */
static	Agdisc_t	*Disc;		/* discipline passed to agread or agconcat */
static gstack_t *S;


#line 139 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int aagdebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum aagtokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    T_graph = 258,                 /* T_graph  */
    T_node = 259,                  /* T_node  */
    T_edge = 260,                  /* T_edge  */
    T_digraph = 261,               /* T_digraph  */
    T_subgraph = 262,              /* T_subgraph  */
    T_strict = 263,                /* T_strict  */
    T_edgeop = 264,                /* T_edgeop  */
    T_list = 265,                  /* T_list  */
    T_attr = 266,                  /* T_attr  */
    T_atom = 267,                  /* T_atom  */
    T_qatom = 268                  /* T_qatom  */
  };
  typedef enum aagtokentype aagtoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define T_graph 258
#define T_node 259
#define T_edge 260
#define T_digraph 261
#define T_subgraph 262
#define T_strict 263
#define T_edgeop 264
#define T_list 265
#define T_attr 266
#define T_atom 267
#define T_qatom 268

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 82 "../../lib/cgraph/grammar.y"

			int				i;
			char			*str;
			struct Agnode_s	*n;

#line 224 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE aaglval;

int aagparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum aagsymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_graph = 3,                    /* T_graph  */
  YYSYMBOL_T_node = 4,                     /* T_node  */
  YYSYMBOL_T_edge = 5,                     /* T_edge  */
  YYSYMBOL_T_digraph = 6,                  /* T_digraph  */
  YYSYMBOL_T_subgraph = 7,                 /* T_subgraph  */
  YYSYMBOL_T_strict = 8,                   /* T_strict  */
  YYSYMBOL_T_edgeop = 9,                   /* T_edgeop  */
  YYSYMBOL_T_list = 10,                    /* T_list  */
  YYSYMBOL_T_attr = 11,                    /* T_attr  */
  YYSYMBOL_T_atom = 12,                    /* T_atom  */
  YYSYMBOL_T_qatom = 13,                   /* T_qatom  */
  YYSYMBOL_14_ = 14,                       /* '{'  */
  YYSYMBOL_15_ = 15,                       /* '}'  */
  YYSYMBOL_16_ = 16,                       /* ';'  */
  YYSYMBOL_17_ = 17,                       /* ','  */
  YYSYMBOL_18_ = 18,                       /* ':'  */
  YYSYMBOL_19_ = 19,                       /* '='  */
  YYSYMBOL_20_ = 20,                       /* '['  */
  YYSYMBOL_21_ = 21,                       /* ']'  */
  YYSYMBOL_22_ = 22,                       /* '@'  */
  YYSYMBOL_23_ = 23,                       /* '+'  */
  YYSYMBOL_YYACCEPT = 24,                  /* $accept  */
  YYSYMBOL_graph = 25,                     /* graph  */
  YYSYMBOL_body = 26,                      /* body  */
  YYSYMBOL_hdr = 27,                       /* hdr  */
  YYSYMBOL_optgraphname = 28,              /* optgraphname  */
  YYSYMBOL_optstrict = 29,                 /* optstrict  */
  YYSYMBOL_graphtype = 30,                 /* graphtype  */
  YYSYMBOL_optstmtlist = 31,               /* optstmtlist  */
  YYSYMBOL_stmtlist = 32,                  /* stmtlist  */
  YYSYMBOL_optsemi = 33,                   /* optsemi  */
  YYSYMBOL_stmt = 34,                      /* stmt  */
  YYSYMBOL_compound = 35,                  /* compound  */
  YYSYMBOL_simple = 36,                    /* simple  */
  YYSYMBOL_rcompound = 37,                 /* rcompound  */
  YYSYMBOL_38_1 = 38,                      /* $@1  */
  YYSYMBOL_39_2 = 39,                      /* $@2  */
  YYSYMBOL_nodelist = 40,                  /* nodelist  */
  YYSYMBOL_node = 41,                      /* node  */
  YYSYMBOL_attrstmt = 42,                  /* attrstmt  */
  YYSYMBOL_attrtype = 43,                  /* attrtype  */
  YYSYMBOL_optmacroname = 44,              /* optmacroname  */
  YYSYMBOL_optattr = 45,                   /* optattr  */
  YYSYMBOL_attrlist = 46,                  /* attrlist  */
  YYSYMBOL_optattrdefs = 47,               /* optattrdefs  */
  YYSYMBOL_attrdefs = 48,                  /* attrdefs  */
  YYSYMBOL_attritem = 49,                  /* attritem  */
  YYSYMBOL_attrassignment = 50,            /* attrassignment  */
  YYSYMBOL_attrmacro = 51,                 /* attrmacro  */
  YYSYMBOL_graphattrdefs = 52,             /* graphattrdefs  */
  YYSYMBOL_subgraph = 53,                  /* subgraph  */
  YYSYMBOL_54_3 = 54,                      /* $@3  */
  YYSYMBOL_optsubghdr = 55,                /* optsubghdr  */
  YYSYMBOL_optseparator = 56,              /* optseparator  */
  YYSYMBOL_atom = 57,                      /* atom  */
  YYSYMBOL_qatom = 58                      /* qatom  */
};
typedef enum aagsymbol_kind_t aagsymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ aagtype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t aagtype_int8;
#else
typedef signed char aagtype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ aagtype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t aagtype_int16;
#else
typedef short aagtype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ aagtype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t aagtype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char aagtype_uint8;
#else
typedef short aagtype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ aagtype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t aagtype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short aagtype_uint16;
#else
typedef int aagtype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef aagtype_int8 aag_state_t;

/* State numbers in computations.  */
typedef int aag_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about aaglval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined aagoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined aagoverflow */

#if (! defined aagoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union aagalloc
{
  aag_state_t aagss_alloc;
  YYSTYPE aagvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union aagalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (aag_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T aagnewbytes;                                         \
        YYCOPY (&aagptr->Stack_alloc, Stack, aagsize);                    \
        Stack = &aagptr->Stack_alloc;                                    \
        aagnewbytes = aagstacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        aagptr += aagnewbytes / YYSIZEOF (*aagptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T aagi;                      \
          for (aagi = 0; aagi < (Count); aagi++)   \
            (Dst)[aagi] = (Src)[aagi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   59

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  24
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  35
/* YYNRULES -- Number of rules.  */
#define YYNRULES  62
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  80

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   268


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by aaglex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (aagsymbol_kind_t, aagtranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by aaglex.  */
static const aagtype_int8 aagtranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    23,    17,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    18,    16,
       2,    19,     2,     2,    22,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    20,     2,    21,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    14,     2,    15,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const aagtype_uint8 aagrline[] =
{
       0,    99,    99,   100,   101,   104,   106,   109,   109,   111,
     111,   113,   113,   115,   115,   117,   117,   119,   119,   121,
     122,   125,   129,   129,   131,   131,   131,   132,   136,   136,
     138,   139,   140,   143,   144,   147,   148,   149,   152,   153,
     156,   156,   158,   160,   161,   163,   166,   166,   168,   171,
     174,   177,   177,   180,   181,   182,   185,   185,   185,   187,
     188,   191,   192
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (aagsymbol_kind_t, aagstos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *aagsymbol_name (aagsymbol_kind_t aagsymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const aagtname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_graph", "T_node",
  "T_edge", "T_digraph", "T_subgraph", "T_strict", "T_edgeop", "T_list",
  "T_attr", "T_atom", "T_qatom", "'{'", "'}'", "';'", "','", "':'", "'='",
  "'['", "']'", "'@'", "'+'", "$accept", "graph", "body", "hdr",
  "optgraphname", "optstrict", "graphtype", "optstmtlist", "stmtlist",
  "optsemi", "stmt", "compound", "simple", "rcompound", "$@1", "$@2",
  "nodelist", "node", "attrstmt", "attrtype", "optmacroname", "optattr",
  "attrlist", "optattrdefs", "attrdefs", "attritem", "attrassignment",
  "attrmacro", "graphattrdefs", "subgraph", "$@3", "optsubghdr",
  "optseparator", "atom", "qatom", YY_NULLPTR
};

static const char *
aagsymbol_name (aagsymbol_kind_t aagsymbol)
{
  return aagtname[aagsymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const aagtype_int16 aagtoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   123,   125,    59,    44,    58,    61,
      91,    93,    64,    43
};
#endif

#define YYPACT_NINF (-18)

#define aagpact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-56)

#define aagtable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const aagtype_int8 aagpact[] =
{
      18,   -18,   -18,    20,     9,     3,   -18,    -2,   -18,   -18,
     -18,     1,   -18,   -18,   -18,     1,   -18,   -18,    10,    -2,
     -18,    19,    25,    21,   -18,    19,     1,   -18,   -18,   -18,
     -18,    11,    17,   -18,   -18,   -18,   -18,   -18,   -18,   -18,
     -18,   -18,     1,   -18,   -18,    22,     9,     1,     1,    29,
      15,    23,   -18,   -18,    26,    23,    27,   -18,   -18,    28,
     -18,   -18,   -18,   -18,     1,    25,    -5,   -18,   -18,   -18,
       1,   -18,    16,   -18,   -18,    30,   -18,   -18,   -18,   -18
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const aagtype_int8 aagdefact[] =
{
       0,     3,     9,     0,     0,     0,     1,    14,     2,    11,
      12,     8,    35,    36,    37,    54,    59,    61,     0,    13,
      16,    18,    27,    22,    28,    18,    39,    50,    34,    23,
      51,    30,    60,     6,     7,    53,     5,    15,    17,    20,
      24,    41,     0,    19,    41,     0,     0,     0,     0,     0,
      55,    21,    40,    29,    30,     0,    33,    38,    52,    31,
      48,    62,    25,    44,     0,    27,     0,    32,    26,    42,
       0,    43,    58,    46,    47,     0,    49,    56,    57,    45
};

  /* YYPGOTO[NTERM-NUM].  */
static const aagtype_int8 aagpgoto[] =
{
     -18,   -18,    -1,   -18,   -18,   -18,   -18,   -18,   -18,    31,
      32,   -18,     0,   -17,   -18,   -18,   -18,    12,   -18,   -18,
     -18,     8,    13,   -18,   -18,   -18,    -8,   -18,   -18,   -18,
     -18,   -18,   -18,   -11,   -18
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const aagtype_int8 aagdefgoto[] =
{
       0,     3,     8,     4,    33,     5,    11,    18,    19,    39,
      20,    21,    22,    41,    50,    65,    23,    24,    25,    26,
      44,    51,    52,    66,    71,    72,    27,    74,    28,    29,
      46,    30,    79,    31,    32
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const aagtype_int8 aagtable[] =
{
      34,    12,    13,    14,    35,    15,     9,    16,    17,    10,
      16,    17,   -55,    16,    17,    45,    69,    70,    -4,     1,
       6,   -10,    15,     7,   -10,    36,     2,    16,    17,    47,
      48,    54,    77,    78,    40,    38,    59,    60,    42,    54,
      49,    57,    61,    63,    47,    58,    64,   -40,    68,    48,
      62,    37,    55,    67,    53,    75,    43,    56,    73,    76
};

static const aagtype_int8 aagcheck[] =
{
      11,     3,     4,     5,    15,     7,     3,    12,    13,     6,
      12,    13,    14,    12,    13,    26,    21,    22,     0,     1,
       0,     3,     7,    14,     6,    15,     8,    12,    13,    18,
      19,    42,    16,    17,     9,    16,    47,    48,    17,    50,
      23,    19,    13,    20,    18,    46,    18,    20,    65,    19,
      50,    19,    44,    64,    42,    66,    25,    44,    66,    70
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const aagtype_int8 aagstos[] =
{
       0,     1,     8,    25,    27,    29,     0,    14,    26,     3,
       6,    30,     3,     4,     5,     7,    12,    13,    31,    32,
      34,    35,    36,    40,    41,    42,    43,    50,    52,    53,
      55,    57,    58,    28,    57,    57,    15,    34,    16,    33,
       9,    37,    17,    33,    44,    57,    54,    18,    19,    23,
      38,    45,    46,    41,    57,    45,    46,    19,    26,    57,
      57,    13,    36,    20,    18,    39,    47,    57,    37,    21,
      22,    48,    49,    50,    51,    57,    57,    16,    17,    56
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const aagtype_int8 aagr1[] =
{
       0,    24,    25,    25,    25,    26,    27,    28,    28,    29,
      29,    30,    30,    31,    31,    32,    32,    33,    33,    34,
      34,    35,    36,    36,    38,    39,    37,    37,    40,    40,
      41,    41,    41,    42,    42,    43,    43,    43,    44,    44,
      45,    45,    46,    47,    47,    48,    49,    49,    50,    51,
      52,    54,    53,    55,    55,    55,    56,    56,    56,    57,
      57,    58,    58
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const aagtype_int8 aagr2[] =
{
       0,     2,     2,     1,     0,     3,     3,     1,     0,     1,
       0,     1,     1,     1,     0,     2,     1,     1,     0,     2,
       2,     3,     1,     1,     0,     0,     5,     0,     1,     3,
       1,     3,     5,     3,     1,     1,     1,     1,     2,     0,
       1,     0,     4,     2,     0,     2,     1,     1,     3,     2,
       1,     0,     3,     2,     1,     0,     1,     1,     0,     1,
       1,     1,     3
};


enum { YYENOMEM = -2 };

#define aagerrok         (aagerrstatus = 0)
#define aagclearin       (aagchar = YYEMPTY)

#define YYACCEPT        goto aagacceptlab
#define YYABORT         goto aagabortlab
#define YYERROR         goto aagerrorlab


#define YYRECOVERING()  (!!aagerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (aagchar == YYEMPTY)                                        \
      {                                                           \
        aagchar = (Token);                                         \
        aaglval = (Value);                                         \
        YYPOPSTACK (aaglen);                                       \
        aagstate = *aagssp;                                         \
        goto aagbackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        aagerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (aagdebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (aagdebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      aag_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
aag_symbol_value_print (FILE *aago,
                       aagsymbol_kind_t aagkind, YYSTYPE const * const aagvaluep)
{
  FILE *aagoutput = aago;
  YY_USE (aagoutput);
  if (!aagvaluep)
    return;
# ifdef YYPRINT
  if (aagkind < YYNTOKENS)
    YYPRINT (aago, aagtoknum[aagkind], *aagvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (aagkind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
aag_symbol_print (FILE *aago,
                 aagsymbol_kind_t aagkind, YYSTYPE const * const aagvaluep)
{
  YYFPRINTF (aago, "%s %s (",
             aagkind < YYNTOKENS ? "token" : "nterm", aagsymbol_name (aagkind));

  aag_symbol_value_print (aago, aagkind, aagvaluep);
  YYFPRINTF (aago, ")");
}

/*------------------------------------------------------------------.
| aag_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
aag_stack_print (aag_state_t *aagbottom, aag_state_t *aagtop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; aagbottom <= aagtop; aagbottom++)
    {
      int aagbot = *aagbottom;
      YYFPRINTF (stderr, " %d", aagbot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (aagdebug)                                                  \
    aag_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
aag_reduce_print (aag_state_t *aagssp, YYSTYPE *aagvsp,
                 int aagrule)
{
  int aaglno = aagrline[aagrule];
  int aagnrhs = aagr2[aagrule];
  int aagi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             aagrule - 1, aaglno);
  /* The symbols being reduced.  */
  for (aagi = 0; aagi < aagnrhs; aagi++)
    {
      YYFPRINTF (stderr, "   $%d = ", aagi + 1);
      aag_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+aagssp[aagi + 1 - aagnrhs]),
                       &aagvsp[(aagi + 1) - (aagnrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (aagdebug)                          \
    aag_reduce_print (aagssp, aagvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int aagdebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
aagdestruct (const char *aagmsg,
            aagsymbol_kind_t aagkind, YYSTYPE *aagvaluep)
{
  YY_USE (aagvaluep);
  if (!aagmsg)
    aagmsg = "Deleting";
  YY_SYMBOL_PRINT (aagmsg, aagkind, aagvaluep, aaglocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (aagkind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int aagchar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE aaglval;
/* Number of syntax errors so far.  */
int aagnerrs;




/*----------.
| aagparse.  |
`----------*/

int
aagparse (void)
{
    aag_state_fast_t aagstate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int aagerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow aagoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T aagstacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    aag_state_t aagssa[YYINITDEPTH];
    aag_state_t *aagss = aagssa;
    aag_state_t *aagssp = aagss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE aagvsa[YYINITDEPTH];
    YYSTYPE *aagvs = aagvsa;
    YYSTYPE *aagvsp = aagvs;

  int aagn;
  /* The return value of aagparse.  */
  int aagresult;
  /* Lookahead symbol kind.  */
  aagsymbol_kind_t aagtoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE aagval;



#define YYPOPSTACK(N)   (aagvsp -= (N), aagssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int aaglen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  aagchar = YYEMPTY; /* Cause a token to be read.  */
  goto aagsetstate;


/*------------------------------------------------------------.
| aagnewstate -- push a new state, which is found in aagstate.  |
`------------------------------------------------------------*/
aagnewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  aagssp++;


/*--------------------------------------------------------------------.
| aagsetstate -- set current state (the top of the stack) to aagstate.  |
`--------------------------------------------------------------------*/
aagsetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", aagstate));
  YY_ASSERT (0 <= aagstate && aagstate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *aagssp = YY_CAST (aag_state_t, aagstate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (aagss, aagssp);

  if (aagss + aagstacksize - 1 <= aagssp)
#if !defined aagoverflow && !defined YYSTACK_RELOCATE
    goto aagexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T aagsize = aagssp - aagss + 1;

# if defined aagoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        aag_state_t *aagss1 = aagss;
        YYSTYPE *aagvs1 = aagvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if aagoverflow is a macro.  */
        aagoverflow (YY_("memory exhausted"),
                    &aagss1, aagsize * YYSIZEOF (*aagssp),
                    &aagvs1, aagsize * YYSIZEOF (*aagvsp),
                    &aagstacksize);
        aagss = aagss1;
        aagvs = aagvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= aagstacksize)
        goto aagexhaustedlab;
      aagstacksize *= 2;
      if (YYMAXDEPTH < aagstacksize)
        aagstacksize = YYMAXDEPTH;

      {
        aag_state_t *aagss1 = aagss;
        union aagalloc *aagptr =
          YY_CAST (union aagalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (aagstacksize))));
        if (! aagptr)
          goto aagexhaustedlab;
        YYSTACK_RELOCATE (aagss_alloc, aagss);
        YYSTACK_RELOCATE (aagvs_alloc, aagvs);
#  undef YYSTACK_RELOCATE
        if (aagss1 != aagssa)
          YYSTACK_FREE (aagss1);
      }
# endif

      aagssp = aagss + aagsize - 1;
      aagvsp = aagvs + aagsize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, aagstacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (aagss + aagstacksize - 1 <= aagssp)
        YYABORT;
    }
#endif /* !defined aagoverflow && !defined YYSTACK_RELOCATE */

  if (aagstate == YYFINAL)
    YYACCEPT;

  goto aagbackup;


/*-----------.
| aagbackup.  |
`-----------*/
aagbackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  aagn = aagpact[aagstate];
  if (aagpact_value_is_default (aagn))
    goto aagdefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (aagchar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      aagchar = aaglex ();
    }

  if (aagchar <= YYEOF)
    {
      aagchar = YYEOF;
      aagtoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (aagchar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      aagchar = YYUNDEF;
      aagtoken = YYSYMBOL_YYerror;
      goto aagerrlab1;
    }
  else
    {
      aagtoken = YYTRANSLATE (aagchar);
      YY_SYMBOL_PRINT ("Next token is", aagtoken, &aaglval, &aaglloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  aagn += aagtoken;
  if (aagn < 0 || YYLAST < aagn || aagcheck[aagn] != aagtoken)
    goto aagdefault;
  aagn = aagtable[aagn];
  if (aagn <= 0)
    {
      if (aagtable_value_is_error (aagn))
        goto aagerrlab;
      aagn = -aagn;
      goto aagreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (aagerrstatus)
    aagerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", aagtoken, &aaglval, &aaglloc);
  aagstate = aagn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++aagvsp = aaglval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  aagchar = YYEMPTY;
  goto aagnewstate;


/*-----------------------------------------------------------.
| aagdefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
aagdefault:
  aagn = aagdefact[aagstate];
  if (aagn == 0)
    goto aagerrlab;
  goto aagreduce;


/*-----------------------------.
| aagreduce -- do a reduction.  |
`-----------------------------*/
aagreduce:
  /* aagn is the number of a rule to reduce with.  */
  aaglen = aagr2[aagn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  aagval = aagvsp[1-aaglen];


  YY_REDUCE_PRINT (aagn);
  switch (aagn)
    {
  case 2: /* graph: hdr body  */
#line 99 "../../lib/cgraph/grammar.y"
                            {freestack(); endgraph();}
#line 1318 "y.tab.c"
    break;

  case 3: /* graph: error  */
#line 100 "../../lib/cgraph/grammar.y"
                                        {if (G) {freestack(); endgraph(); agclose(G); G = Ag_G_global = NIL(Agraph_t*);}}
#line 1324 "y.tab.c"
    break;

  case 6: /* hdr: optstrict graphtype optgraphname  */
#line 106 "../../lib/cgraph/grammar.y"
                                                                 {startgraph((aagvsp[0].str),(aagvsp[-1].i),(aagvsp[-2].i));}
#line 1330 "y.tab.c"
    break;

  case 7: /* optgraphname: atom  */
#line 109 "../../lib/cgraph/grammar.y"
                     {(aagval.str)=(aagvsp[0].str);}
#line 1336 "y.tab.c"
    break;

  case 8: /* optgraphname: %empty  */
#line 109 "../../lib/cgraph/grammar.y"
                                            {(aagval.str)=0;}
#line 1342 "y.tab.c"
    break;

  case 9: /* optstrict: T_strict  */
#line 111 "../../lib/cgraph/grammar.y"
                             {(aagval.i)=1;}
#line 1348 "y.tab.c"
    break;

  case 10: /* optstrict: %empty  */
#line 111 "../../lib/cgraph/grammar.y"
                                                    {(aagval.i)=0;}
#line 1354 "y.tab.c"
    break;

  case 11: /* graphtype: T_graph  */
#line 113 "../../lib/cgraph/grammar.y"
                                {(aagval.i) = 0;}
#line 1360 "y.tab.c"
    break;

  case 12: /* graphtype: T_digraph  */
#line 113 "../../lib/cgraph/grammar.y"
                                                          {(aagval.i) = 1;}
#line 1366 "y.tab.c"
    break;

  case 21: /* compound: simple rcompound optattr  */
#line 126 "../../lib/cgraph/grammar.y"
                                        {if ((aagvsp[-1].i)) endedge(); else endnode();}
#line 1372 "y.tab.c"
    break;

  case 24: /* $@1: %empty  */
#line 131 "../../lib/cgraph/grammar.y"
                                 {getedgeitems(1);}
#line 1378 "y.tab.c"
    break;

  case 25: /* $@2: %empty  */
#line 131 "../../lib/cgraph/grammar.y"
                                                           {getedgeitems(2);}
#line 1384 "y.tab.c"
    break;

  case 26: /* rcompound: T_edgeop $@1 simple $@2 rcompound  */
#line 131 "../../lib/cgraph/grammar.y"
                                                                                        {(aagval.i) = 1;}
#line 1390 "y.tab.c"
    break;

  case 27: /* rcompound: %empty  */
#line 132 "../../lib/cgraph/grammar.y"
                                            {(aagval.i) = 0;}
#line 1396 "y.tab.c"
    break;

  case 30: /* node: atom  */
#line 138 "../../lib/cgraph/grammar.y"
                       {appendnode((aagvsp[0].str),NIL(char*),NIL(char*));}
#line 1402 "y.tab.c"
    break;

  case 31: /* node: atom ':' atom  */
#line 139 "../../lib/cgraph/grammar.y"
                            {appendnode((aagvsp[-2].str),(aagvsp[0].str),NIL(char*));}
#line 1408 "y.tab.c"
    break;

  case 32: /* node: atom ':' atom ':' atom  */
#line 140 "../../lib/cgraph/grammar.y"
                                     {appendnode((aagvsp[-4].str),(aagvsp[-2].str),(aagvsp[0].str));}
#line 1414 "y.tab.c"
    break;

  case 33: /* attrstmt: attrtype optmacroname attrlist  */
#line 143 "../../lib/cgraph/grammar.y"
                                                  {attrstmt((aagvsp[-2].i),(aagvsp[-1].str));}
#line 1420 "y.tab.c"
    break;

  case 34: /* attrstmt: graphattrdefs  */
#line 144 "../../lib/cgraph/grammar.y"
                                         {attrstmt(T_graph,NIL(char*));}
#line 1426 "y.tab.c"
    break;

  case 35: /* attrtype: T_graph  */
#line 147 "../../lib/cgraph/grammar.y"
                        {(aagval.i) = T_graph;}
#line 1432 "y.tab.c"
    break;

  case 36: /* attrtype: T_node  */
#line 148 "../../lib/cgraph/grammar.y"
                                 {(aagval.i) = T_node;}
#line 1438 "y.tab.c"
    break;

  case 37: /* attrtype: T_edge  */
#line 149 "../../lib/cgraph/grammar.y"
                                 {(aagval.i) = T_edge;}
#line 1444 "y.tab.c"
    break;

  case 38: /* optmacroname: atom '='  */
#line 152 "../../lib/cgraph/grammar.y"
                        {(aagval.str) = (aagvsp[-1].str);}
#line 1450 "y.tab.c"
    break;

  case 39: /* optmacroname: %empty  */
#line 153 "../../lib/cgraph/grammar.y"
                                      {(aagval.str) = NIL(char*); }
#line 1456 "y.tab.c"
    break;

  case 48: /* attrassignment: atom '=' atom  */
#line 168 "../../lib/cgraph/grammar.y"
                                 {appendattr((aagvsp[-2].str),(aagvsp[0].str));}
#line 1462 "y.tab.c"
    break;

  case 49: /* attrmacro: '@' atom  */
#line 171 "../../lib/cgraph/grammar.y"
                                 {appendattr((aagvsp[0].str),NIL(char*));}
#line 1468 "y.tab.c"
    break;

  case 51: /* $@3: %empty  */
#line 177 "../../lib/cgraph/grammar.y"
                              {opensubg((aagvsp[0].str));}
#line 1474 "y.tab.c"
    break;

  case 52: /* subgraph: optsubghdr $@3 body  */
#line 177 "../../lib/cgraph/grammar.y"
                                                   {closesubg();}
#line 1480 "y.tab.c"
    break;

  case 53: /* optsubghdr: T_subgraph atom  */
#line 180 "../../lib/cgraph/grammar.y"
                                  {(aagval.str)=(aagvsp[0].str);}
#line 1486 "y.tab.c"
    break;

  case 54: /* optsubghdr: T_subgraph  */
#line 181 "../../lib/cgraph/grammar.y"
                                      {(aagval.str)=NIL(char*);}
#line 1492 "y.tab.c"
    break;

  case 55: /* optsubghdr: %empty  */
#line 182 "../../lib/cgraph/grammar.y"
                                      {(aagval.str)=NIL(char*);}
#line 1498 "y.tab.c"
    break;

  case 59: /* atom: T_atom  */
#line 187 "../../lib/cgraph/grammar.y"
                  {(aagval.str) = (aagvsp[0].str);}
#line 1504 "y.tab.c"
    break;

  case 60: /* atom: qatom  */
#line 188 "../../lib/cgraph/grammar.y"
                                 {(aagval.str) = (aagvsp[0].str);}
#line 1510 "y.tab.c"
    break;

  case 61: /* qatom: T_qatom  */
#line 191 "../../lib/cgraph/grammar.y"
                   {(aagval.str) = (aagvsp[0].str);}
#line 1516 "y.tab.c"
    break;

  case 62: /* qatom: qatom '+' T_qatom  */
#line 192 "../../lib/cgraph/grammar.y"
                                             {(aagval.str) = concat((aagvsp[-2].str),(aagvsp[0].str));}
#line 1522 "y.tab.c"
    break;


#line 1526 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter aagchar, and that requires
     that aagtoken be updated with the new translation.  We take the
     approach of translating immediately before every use of aagtoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering aagchar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (aagsymbol_kind_t, aagr1[aagn]), &aagval, &aagloc);

  YYPOPSTACK (aaglen);
  aaglen = 0;

  *++aagvsp = aagval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int aaglhs = aagr1[aagn] - YYNTOKENS;
    const int aagi = aagpgoto[aaglhs] + *aagssp;
    aagstate = (0 <= aagi && aagi <= YYLAST && aagcheck[aagi] == *aagssp
               ? aagtable[aagi]
               : aagdefgoto[aaglhs]);
  }

  goto aagnewstate;


/*--------------------------------------.
| aagerrlab -- here on detecting error.  |
`--------------------------------------*/
aagerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  aagtoken = aagchar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (aagchar);
  /* If not already recovering from an error, report this error.  */
  if (!aagerrstatus)
    {
      ++aagnerrs;
      aagerror (YY_("syntax error"));
    }

  if (aagerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (aagchar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (aagchar == YYEOF)
            YYABORT;
        }
      else
        {
          aagdestruct ("Error: discarding",
                      aagtoken, &aaglval);
          aagchar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto aagerrlab1;


/*---------------------------------------------------.
| aagerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
aagerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label aagerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (aaglen);
  aaglen = 0;
  YY_STACK_PRINT (aagss, aagssp);
  aagstate = *aagssp;
  goto aagerrlab1;


/*-------------------------------------------------------------.
| aagerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
aagerrlab1:
  aagerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      aagn = aagpact[aagstate];
      if (!aagpact_value_is_default (aagn))
        {
          aagn += YYSYMBOL_YYerror;
          if (0 <= aagn && aagn <= YYLAST && aagcheck[aagn] == YYSYMBOL_YYerror)
            {
              aagn = aagtable[aagn];
              if (0 < aagn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (aagssp == aagss)
        YYABORT;


      aagdestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (aagstate), aagvsp);
      YYPOPSTACK (1);
      aagstate = *aagssp;
      YY_STACK_PRINT (aagss, aagssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++aagvsp = aaglval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (aagn), aagvsp, aaglsp);

  aagstate = aagn;
  goto aagnewstate;


/*-------------------------------------.
| aagacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
aagacceptlab:
  aagresult = 0;
  goto aagreturn;


/*-----------------------------------.
| aagabortlab -- YYABORT comes here.  |
`-----------------------------------*/
aagabortlab:
  aagresult = 1;
  goto aagreturn;


#if !defined aagoverflow
/*-------------------------------------------------.
| aagexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
aagexhaustedlab:
  aagerror (YY_("memory exhausted"));
  aagresult = 2;
  goto aagreturn;
#endif


/*-------------------------------------------------------.
| aagreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
aagreturn:
  if (aagchar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      aagtoken = YYTRANSLATE (aagchar);
      aagdestruct ("Cleanup: discarding lookahead",
                  aagtoken, &aaglval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (aaglen);
  YY_STACK_PRINT (aagss, aagssp);
  while (aagssp != aagss)
    {
      aagdestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*aagssp), aagvsp);
      YYPOPSTACK (1);
    }
#ifndef aagoverflow
  if (aagss != aagssa)
    YYSTACK_FREE (aagss);
#endif

  return aagresult;
}

#line 194 "../../lib/cgraph/grammar.y"


#define NILitem  NIL(item*)


static item *newitem(int tag, void *p0, char *p1)
{
	item	*rv = agalloc(G,sizeof(item));
	rv->tag = tag; rv->u.name = (char*)p0; rv->str = p1;
	return rv;
}

static item *cons_node(Agnode_t *n, char *port)
	{ return newitem(T_node,n,port); }

static item *cons_attr(char *name, char *value)
	{ return newitem(T_atom,name,value); }

static item *cons_list(item *list)
	{ return newitem(T_list,list,NIL(char*)); }

static item *cons_subg(Agraph_t *subg)
	{ return newitem(T_subgraph,subg,NIL(char*)); }

static gstack_t *push(gstack_t *s, Agraph_t *subg) {
	gstack_t *rv;
	rv = agalloc(G,sizeof(gstack_t));
	rv->down = s;
	rv->g = subg;
	return rv;
}

static gstack_t *pop(gstack_t *s)
{
	gstack_t *rv;
	rv = S->down;
	agfree(G,s);
	return rv;
}

#ifdef NOTDEF
static item *cons_edge(Agedge_t *e)
	{ return newitem(T_edge,e,NIL(char*)); }
#endif

static void delete_items(item *ilist)
{
	item	*p,*pn;

	for (p = ilist; p; p = pn) {
		pn = p->next;
		switch(p->tag) {
			case T_list: delete_items(p->u.list); break;
			case T_atom: case T_attr: agstrfree(G,p->str); break;
		}
		agfree(G,p);
	}
}

#ifdef NOTDEF
static void initlist(list_t *list)
{
	list->first = list->last = NILitem;
}
#endif

static void deletelist(list_t *list)
{
	delete_items(list->first);
	list->first = list->last = NILitem;
}

#ifdef NOTDEF
static void listins(list_t *list, item *v)
{
	v->next = list->first;
	list->first = v;
	if (list->last == NILitem) list->last = v;
}
#endif

static void listapp(list_t *list, item *v)
{
	if (list->last) list->last->next = v;
	list->last = v;
	if (list->first == NILitem) list->first = v;
}


/* attrs */
static void appendattr(char *name, char *value)
{
	item		*v;

	assert(value != NIL(char*));
	v = cons_attr(name,value);
	listapp(&(S->attrlist),v);
}

static void bindattrs(int kind)
{
	item		*aptr;
	char		*name;

	for (aptr = S->attrlist.first; aptr; aptr = aptr->next) {
		assert(aptr->tag == T_atom);	/* signifies unbound attr */
		name = aptr->u.name;
		if ((kind == AGEDGE) && streq(name,Key)) continue;
		if ((aptr->u.asym = agattr(S->g,kind,name,NIL(char*))) == NILsym)
			aptr->u.asym = agattr(S->g,kind,name,"");
		aptr->tag = T_attr;				/* signifies bound attr */
		agstrfree(G,name);
	}
}

/* attach node/edge specific attributes */
static void applyattrs(void *obj)
{
	item		*aptr;

	for (aptr = S->attrlist.first; aptr; aptr = aptr->next) {
		if (aptr->tag == T_attr) {
			if (aptr->u.asym) {
				agxset(obj,aptr->u.asym,aptr->str);
			}
		}
		else {
			/* assert(AGTYPE(obj) == AGEDGE);  surprising this fails */
			assert((AGTYPE(obj) == AGINEDGE) || (AGTYPE(obj) == AGOUTEDGE));
			assert(aptr->tag == T_atom);
			assert(streq(aptr->u.name,Key));
		}
	}
}

static void nomacros(void)
{
	agerr(AGWARN,"attribute macros not implemented");
}

/* attrstmt:
 * First argument is always attrtype, so switch covers all cases.
 * This function is used to handle default attribute value assignment.
 */
static void attrstmt(int tkind, char *macroname)
{
	item			*aptr;
	int				kind = 0;
	Agsym_t*  sym;

		/* creating a macro def */
	if (macroname) nomacros();
		/* invoking a macro def */
	for (aptr = S->attrlist.first; aptr; aptr = aptr->next)
		if (aptr->str == NIL(char*)) nomacros();

	switch(tkind) {
		case T_graph: kind = AGRAPH; break;
		case T_node: kind = AGNODE; break;
		case T_edge: kind = AGEDGE; break;
	}
	bindattrs(kind);	/* set up defaults for new attributes */
	for (aptr = S->attrlist.first; aptr; aptr = aptr->next) {
		/* If the tag is still T_atom, aptr->u.asym has not been set */
		if (aptr->tag == T_atom) continue;
		if (!(aptr->u.asym->fixed) || (S->g != G))
			sym = agattr(S->g,kind,aptr->u.asym->name,aptr->str);
		else
			sym = aptr->u.asym;
		if (S->g == G)
			sym->print = TRUE;
	}
	deletelist(&(S->attrlist));
}

/* nodes */

static void appendnode(char *name, char *port, char *sport)
{
	item		*elt;

	if (sport) {
		port = concatPort (port, sport);
	}
	elt = cons_node(agnode(S->g,name,TRUE),port);
	listapp(&(S->nodelist),elt);
	agstrfree(G,name);
}

/* apply current optional attrs to nodelist and clean up lists */
/* what's bad is that this could also be endsubg.  also, you can't
clean up S->subg in closesubg() because S->subg might be needed
to construct edges.  these are the sort of notes you write to yourself
in the future. */
static void endnode()
{
	item	*ptr;

	bindattrs(AGNODE);
	for (ptr = S->nodelist.first; ptr; ptr = ptr->next)
		applyattrs(ptr->u.n);
	deletelist(&(S->nodelist));
	deletelist(&(S->attrlist));
	deletelist(&(S->edgelist));
	S->subg = 0;  /* notice a pattern here? :-( */
}

/* edges - store up node/subg lists until optional edge key can be seen */

static void getedgeitems(int x)
{
	item	*v = 0;

	if (S->nodelist.first) {
		v = cons_list(S->nodelist.first);
		S->nodelist.first = S->nodelist.last = NILitem;
	}
	else {if (S->subg) v = cons_subg(S->subg); S->subg = 0;}
	/* else nil append */
	if (v) listapp(&(S->edgelist),v);
}

static void endedge(void)
{
	char			*key;
	item			*aptr,*tptr,*p;

	Agnode_t		*t;
	Agraph_t		*subg;

	bindattrs(AGEDGE);

	/* look for "key" pseudo-attribute */
	key = NIL(char*);
	for (aptr = S->attrlist.first; aptr; aptr = aptr->next) {
		if ((aptr->tag == T_atom) && streq(aptr->u.name,Key))
			key = aptr->str;
	}

	/* can make edges with node lists or subgraphs */
	for (p = S->edgelist.first; p->next; p = p->next) {
		if (p->tag == T_subgraph) {
			subg = p->u.subg;
			for (t = agfstnode(subg); t; t = agnxtnode(subg,t))
				edgerhs(agsubnode(S->g,t,FALSE),NIL(char*),p->next,key);
		}
		else {
			for (tptr = p->u.list; tptr; tptr = tptr->next)
				edgerhs(tptr->u.n,tptr->str,p->next,key);
		}
	}
	deletelist(&(S->nodelist));
	deletelist(&(S->edgelist));
	deletelist(&(S->attrlist));
	S->subg = 0;
}

/* concat:
 */
static char*
concat (char* s1, char* s2)
{
  char*  s;
  char   buf[BUFSIZ];
  char*  sym;
  size_t len = strlen(s1) + strlen(s2) + 1;

  if (len <= BUFSIZ) sym = buf;
  else sym = (char*)malloc(len);
  strcpy(sym,s1);
  strcat(sym,s2);
  s = agstrdup (G,sym);
  agstrfree (G,s1);
  agstrfree (G,s2);
  if (sym != buf) free (sym);
  return s;
}

/* concatPort:
 */
static char*
concatPort (char* s1, char* s2)
{
  char*  s;
  char   buf[BUFSIZ];
  char*  sym;
  size_t len = strlen(s1) + strlen(s2) + 2;  /* one more for ':' */

  if (len <= BUFSIZ) sym = buf;
  else sym = (char*)malloc(len);
  sprintf (sym, "%s:%s", s1, s2);
  s = agstrdup (G,sym);
  agstrfree (G,s1);
  agstrfree (G,s2);
  if (sym != buf) free (sym);
  return s;
}


static void edgerhs(Agnode_t *tail, char *tport, item *hlist, char *key)
{
	Agnode_t		*head;
	Agraph_t		*subg;
	item			*hptr;

	if (hlist->tag == T_subgraph) {
		subg = hlist->u.subg;
		for (head = agfstnode(subg); head; head = agnxtnode(subg,head))
			newedge(tail,tport,agsubnode(S->g,head,FALSE),NIL(char*),key);
	}
	else {
		for (hptr = hlist->u.list; hptr; hptr = hptr->next)
			newedge(tail,tport,agsubnode(S->g,hptr->u.n,FALSE),hptr->str,key);
	}
}

static void mkport(Agedge_t *e, char *name, char *val)
{
	Agsym_t *attr;
	if (val) {
		if ((attr = agattr(S->g,AGEDGE,name,NIL(char*))) == NILsym)
			attr = agattr(S->g,AGEDGE,name,"");
		agxset(e,attr,val);
	}
}

static void newedge(Agnode_t *t, char *tport, Agnode_t *h, char *hport, char *key)
{
	Agedge_t 	*e;

	e = agedge(S->g,t,h,key,TRUE);
	if (e) {		/* can fail if graph is strict and t==h */
		char    *tp = tport;
		char    *hp = hport;
		if ((agtail(e) != aghead(e)) && (aghead(e) == t)) {
			/* could happen with an undirected edge */
			char    *temp;
			temp = tp; tp = hp; hp = temp;
		}
		mkport(e,TAILPORT_ID,tp);
		mkport(e,HEADPORT_ID,hp);
		applyattrs(e);
	}
}

/* graphs and subgraphs */


static void startgraph(char *name, int directed, int strict)
{
	static Agdesc_t	req;	/* get rid of warnings */

	if (G == NILgraph) {
    SubgraphDepth = 0;
		req.directed = directed;
		req.strict = strict;
		req.maingraph = TRUE;
		Ag_G_global = G = agopen(name,req,Disc);
	}
	else {
		Ag_G_global = G;
	}
	S = push(S,G);
	agstrfree(NIL(Agraph_t*),name);
}

static void endgraph()
{
	aglexeof();
	aginternalmapclearlocalnames(G);
}

static void opensubg(char *name)
{
  if (++SubgraphDepth >= YYMAXDEPTH/2) {
    char buf[128];
    sprintf(buf,"subgraphs nested more than %d deep",YYMAXDEPTH);
    agerr(AGERR,buf);
  }
	S = push(S,agsubg(S->g,name,TRUE));
	agstrfree(G,name);
}

static void closesubg()
{
	Agraph_t *subg = S->g;
  --SubgraphDepth;
	S = pop(S);
	S->subg = subg;
	assert(subg);
}

static void freestack()
{
	while (S) {
		deletelist(&(S->nodelist));
		deletelist(&(S->attrlist));
		deletelist(&(S->edgelist));
		S = pop(S);
	}
}

extern FILE *aagin;
Agraph_t *agconcat(Agraph_t *g, void *chan, Agdisc_t *disc)
{
	aagin = chan;
	G = g;
	Ag_G_global = NILgraph;
	Disc = (disc? disc :  &AgDefaultDisc);
	aglexinit(Disc, chan);
	aagparse();
	if (Ag_G_global == NILgraph) aglexbad();
	return Ag_G_global;
}

Agraph_t *agread(void *fp, Agdisc_t *disc) {return agconcat(NILgraph,fp,disc); }

